//
//	Battery discharge capacities meter 0.1
//		adc.c: A/D converter support
//		2009.03.16 1st rel
//			(c)2009 T.Togashi
//
#include	<htc.h>
#include	"adc.h"

void
adc_start(
	unsigned char channel
) {

	//	Port pin
	switch(channel) {
	case 0:
		ANS0   = 1;		/* ANALOG */
		TRISA0 = 1;		/* input */
		break;
	case 1:
		ANS1   = 1;		/* ANALOG */
		TRISA1 = 1;		/* input */
		break;
	case 2:
		ANS2   = 1;		/* ANALOG */
		TRISA2 = 1;		/* input */
		break;
	case 3:
		ANS3   = 1;		/* ANALOG */
		TRISA3 = 1;		/* input */
		break;
	case 4:
		ANS4   = 1;		/* ANALOG */
		TRISA4 = 1;		/* input */
		break;
	case 5:
		ANS5   = 1;		/* ANALOG */
		TRISB6 = 1;		/* input */
		break;
	case 6:
		ANS6   = 1;		/* ANALOG */
		TRISB7 = 1;		/* input */
		break;
	default:
		return;
	}

//	A/D module init
//	ANS3   = 1;		/* Ref+ ANALOG */
//	TRISA3 = 1;		/* Ref+ input */
	ADCON0 = 0b10000001 | (channel << 3);
//             xx...... ADCS: Tosc 00=2,4 01=8,16 10=32,64 11=RC
//             ..xxx... CHS: input channel
//             .....x.. GO/DONE: 1=go 0=done
//             .......x ADON: 1=on 0=shutdown
	ADCON1 = 0b10000000;
//             x....... ADFM: 1=Right 0=Left jusstified
//             .x...... ADCS: Tosc 0=2,8,32 1=4,16,64
//             ..xx.... VCFG: Vref 00=+Vdd-Vss 01=+Vdd-RA2 10=+RA3-Vss 11=+RA3-RA2
	return;
}

void
adc_stop() {
	ADCON0 = 0b00000000;
//             .......x ADON: 1=on 0=shutdown
	return;
}

/* Return an 16 bit result */
int
adc_read(
	unsigned char channel
) {
	ADCON0 = (ADCON0 & 0b11000111) | ((channel & 0b00000111) << 3);
	ADGO   = 1;
	while(ADGO)continue;
	return((ADRESH << 8) | ADRESL);	// return result
}